<template>
  <div
    class="sa-dropdown"
    data-testid="dropdown"
    @focusout="onDropdownFocusOut"
  >
    <sa-button
      :id="uniqueId"
      ref="button"
      class="dropdown-button"
      :size="size"
      :type="type"
      :text="text"
      :avatar="avatar"
      :icon="icon"
      :icon-only="iconOnly"
      :icon-right="iconRight"
      aria-haspopup="true"
      :aria-expanded="dropdownOpen"
      :data-testid="text"
      @click="toggleDropdown()"
    />
    <div
      v-show="dropdownOpen"
      ref="dropdown"
      class="dropdown"
      :class="align"
      tabindex="-1"
      role="listbox"
      :aria-labelledby="uniqueId"
      :data-testid="dropdownOpen"
      @click="handleClickInsideDropdown"
    >
      <!-- @slot Content to show in the dropdown panel -->
      <slot></slot>
    </div>
  </div>
</template>

<script>
export default {
  name: 'SaDropdown',
  props: {
    /** @values primary, success, error */
    type: {
      type: String,
      default: 'primary'
    },
    /** @values small, regular, large */
    size: {
      type: String,
      default: 'regular'
    },
    /** Button label */
    text: {
      type: String,
      required: true
    },
    /** Name of icon to show in button. See `icon` component docs for available names. */
    icon: {
      type: String,
      default: ''
    },
    /** Show button with icon only. The `text` prop is still used for screen readers. */
    iconOnly: {
      type: Boolean,
      default: false
    },
    /** Show icon on the right-hand side of the text. */
    iconRight: {
      type: Boolean,
      default: false
    },
    /**
     * Which side to align the button and dropdown panel
     * @values left, right
     */
    align: {
      type: String,
      default: 'left'
    },
    /** Name of user to show an `avatar` for. */
    avatar: {
      type: String,
      default: ''
    },
    /** Dropdown box will stay open when interacted within box area */
    staysOpen: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      dropdownOpen: false,
      uniqueId: this.makeUniqueId()
    }
  },
  mounted() {
    document.addEventListener('click', this.handleOutsideClick)
  },
  beforeDestroy() {
    document.removeEventListener('click', this.handleOutsideClick)
  },
  methods: {
    toggleDropdown() {
      if (!this.dropdownOpen) {
        this.dropdownOpen = true
        setTimeout(() => this.$refs.dropdown.focus())
      } else {
        this.closeDropdown()
      }
    },
    closeDropdown() {
      this.dropdownOpen = false
    },
    onDropdownFocusOut(e) {
      if (!e.currentTarget.contains(e.relatedTarget)) {
        this.closeDropdown()
      }
    },
    handleOutsideClick(e) {
      // check if the click event was outside the dropdown box
      if (this.$el.contains(e.target)) {
        // click was inside the dropdown box, do nothing
      } else {
        // click was outside the dropdown box, close it
        this.closeDropdown()
      }
    },
    handleClickInsideDropdown() {
      if (!this.staysOpen) {
        this.closeDropdown()
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.sa-dropdown {
  position: relative;
}
</style>
